Sjasm Z80 Assembler v0.42c - www.xl2s.tk             [2023.01.05 - 23:10:55]

C:\USB-ZX81\sjasm\SOKOB256\sokob256-011.asm
Errors: 0

       1   00:8010                      		org 	32784
       2   00:8010                      
       3   00:8010                      ; SOKOB 1/4 
       4   00:8010                      ; Sokoban in just 1/4K with 4 levels
       5   00:8010                      
       6   00:8010                      ; Controls
       7   00:8010                      ; Q = up
       8   00:8010                      ; A = down
       9   00:8010                      ; O = left
      10   00:8010                      ; P = right
      11   00:8010                      ; R = restart level
      12   00:8010                      ; N = next level
      13   00:8010                      
      14   00:8010                      ; You control the black cursor and you need to 
      15   00:8010                      ; move blue boxes onto the yellow fields.
      16   00:8010                       
      17   00:8010  32 8D 5C            		ld 	(23693),a	; walls are as of now red
      18   00:8013                      
      19   00:8013  21 D8 80            start		ld 	hl,levels-1	; pointer to leveldata
      20   00:8016  E5                  nlev		push	hl
      21   00:8017  CD AF 0D            		call    #daf		; clear screen into red
      22   00:801A  E1                  		pop	hl
      23   00:801B                      
      24   00:801B  7D                  	 	ld	a,l
      25   00:801C  FE 0D               		cp	endlevel%256-1	; test end of levels reached
      26   00:801E  28 F3               		jr	z,start		; to first level again after 4 levels
      27   00:8020                      
      28   00:8020  E5                  		push 	hl		; save start of level
      29   00:8021                      
      30   00:8021  01 08 01            		ld 	bc,#108		; xy coordinates to start display
      31   00:8024                      
      32   00:8024  23                  displevel	inc 	hl		; next field in level
      33   00:8025  5E                  		ld 	e,(hl)		; save data
      34   00:8026  CD A6 80            		call	print		; test and display nibble
      35   00:8029  C4 A6 80            		call	nz,print	; test and display nibble
      36   00:802C  73                  stlevel		ld 	(hl),e		; repair data
      37   00:802D  20 F5               		jr 	nz,displevel	; show level
      38   00:802F                      
      39   00:802F  DD 63               		ld 	ixh,e		; save nr fields in ixh
      40   00:8031  D9                  		exx			; start next level saved in shadowregisters
      41   00:8032                      		
      42   00:8032  01 00 00            xypos   	ld 	bc,0		; player coordinates
      43   00:8035  CD CB 80            		call 	attr		; calculate field
      44   00:8038                      
      45   00:8038  5F                  		ld	e,a
      46   00:8039  AF                  		xor	a
      47   00:803A  77                  		ld 	(hl),a		; show player as black cursor
      48   00:803B                      		
      49   00:803B  E5                  		push	hl		; save current field
      50   00:803C  21 08 5C            		ld 	hl,23560
      51   00:803F  77                  		ld	(hl),a		; erase old key
      52   00:8040  B6                  wkey		or	(hl)		; wait for debounce or new key
      53   00:8041  28 FD               		jr	z,wkey
      54   00:8043  E1                  		pop	hl		; get current field
      55   00:8044                      
      56   00:8044  73                  		ld 	(hl),e		; repair background
      57   00:8045                      
      58   00:8045  E1                  		pop	hl		; get old level
      59   00:8046  FE 72               		cp	"r"		; test restart			
      60   00:8048  28 CC               		jr 	z,nlev		; draw again		
      61   00:804A  E5                  		push	hl		; save level
      62   00:804B                      
      63   00:804B  FE 6E               		cp	"n"		; test skip level
      64   00:804D  28 52               		jr	z,nkey		; skip a level
      65   00:804F                      
      66   00:804F  59                  notnkey		ld	e,c
      67   00:8050  50                  		ld	d,b
      68   00:8051                      
      69   00:8051  FE 71               		cp 	"q"		; move up?
      70   00:8053  20 03               		jr 	nz,t2
      71   00:8055  05                  		dec 	b		; 1 field up
      72   00:8056  50                  		ld	d,b		; d goes 2 fields up
      73   00:8057  15                  		dec 	d
      74   00:8058  FE 61               t2		cp 	"a"		; move down?
      75   00:805A  20 03               		jr 	nz,t3
      76   00:805C  04                  		inc 	b		; 1 field down
      77   00:805D  50                  		ld 	d,b		; d goes 2 fields down
      78   00:805E  14                  		inc 	d
      79   00:805F  FE 6F               t3		cp 	"o"		; move left?
      80   00:8061  20 03               		jr 	nz,t4
      81   00:8063  0D                  		dec 	c		; 1 field left
      82   00:8064  59                  		ld 	e,c		; e goes 2 fields left
      83   00:8065  1D                  		dec 	e
      84   00:8066  FE 70               t4		cp 	"p"		; move right?
      85   00:8068  20 03               		jr 	nz,endkeys	; all keys tested now test move
      86   00:806A  0C                  		inc 	c		; 1 field right
      87   00:806B  59                  		ld	e,c		; e goes 2 fields right
      88   00:806C  1C                  		inc 	e
      89   00:806D  CD CB 80            endkeys		call 	attr		; check 1 step screenpos 
      90   00:8070  28 06               		jr 	z,testbox	; we move a box
      91   00:8072  38 20               		jr 	c,setxy		; move to an empty field ok
      92   00:8074                      
      93   00:8074  FE 1F               		cp 	31		; is it box on end?			
      94   00:8076  38 20               		jr 	c,free_end	; no box on field leaves wall
      95   00:8078                      
      96   00:8078  08                  testbox		ex 	af,af'		; save current test, box on end or normal box
      97   00:8079  C5                  		push 	bc		; save new xy
      98   00:807A  42                  		ld 	b,d		; get 2 step position
      99   00:807B  4B                  		ld 	c,e
     100   00:807C  CD CB 80            		call 	attr		; test 2 position screenpos
     101   00:807F  C1                  		pop 	bc		; get new xy back
     102   00:8080                      			
     103   00:8080  30 B0               		jr 	nc,xypos	; move box to box or box to wall
     104   00:8082                      
     105   00:8082  FE 30               		cp 	48		; will it go to endfield?
     106   00:8084  CB A6               		res	4,(hl)		; display block on new field
     107   00:8086  20 02               		jr 	nz,not2end	; but not on end	
     108   00:8088                      
     109   00:8088  DD 25               		dec 	ixh		; another box on end		
     110   00:808A                      
     111   00:808A  08                  not2end		ex 	af,af'		; get test field from
     112   00:808B  28 02               		jr 	z,notfromend	; no box from end
     113   00:808D                      
     114   00:808D  DD 24               		inc 	ixh		; another endpos free
     115   00:808F                      
     116   00:808F  CD CB 80            notfromend	call 	attr		; get screenfield
     117   00:8092  CB E6               		set 	4,(hl)		; display right character
     118   00:8094                      
     119   00:8094  ED 43 33 80         setxy		ld 	(xypos+1),bc	; save new xy
     120   00:8098                      
     121   00:8098  DD 7C               free_end	ld 	a,ixh		; test all boxes on end
     122   00:809A                      
     123   00:809A  B7                  		or 	a
     124   00:809B  20 95               		jr 	nz,xypos	; not ready, keep playing
     125   00:809D                      
     126   00:809D  44                  		ld	b,h		; celebrationloop
     127   00:809E  76                  wait		halt
     128   00:809F  10 FD               		djnz    wait
     129   00:80A1                      
     130   00:80A1                      
     131   00:80A1  E1                  nkey		pop	hl		; drop old level
     132   00:80A2  D9                  		exx			; new level
     133   00:80A3  C3 16 80            		jp 	nlev
     134   00:80A6                      
     135   00:80A6  AF                  print		xor	a
     136   00:80A7  ED 6F               		rld
     137   00:80A9  C8                  		ret	z
     138   00:80AA                      
     139   00:80AA  1F                  		rra			; test compressed data
     140   00:80AB  F5                  		push 	af		; save result
     141   00:80AC  DC B0 80            		call 	c,pr1		; if bit 0 set, double display of value
     142   00:80AF  F1                  		pop 	af		; get data back from call
     143   00:80B0  E5                  pr1		push 	hl		; save levelpointer
     144   00:80B1  FE 01               		cp 	1		; test startposition player
     145   00:80B3  20 06               		jr 	nz,dodisp	; if not continue
     146   00:80B5  ED 43 33 80         		ld 	(xypos+1),bc	; save startposition
     147   00:80B9  3E 07               		ld 	a,7		; display as a space
     148   00:80BB  F5                  dodisp		push 	af		; save data
     149   00:80BC  CD CB 80            		call 	attr		; calculate field
     150   00:80BF  F1                  		pop 	af		; get data
     151   00:80C0  87                  		add 	a,a		; multiply by 8 for colour
     152   00:80C1  87                  		add 	a,a
     153   00:80C2  87                  		add 	a,a
     154   00:80C3  77                  		ld 	(hl),a		; write item
     155   00:80C4                      
     156   00:80C4  0D                  		dec 	c		; next field
     157   00:80C5  E1                  		pop 	hl		; get leveldata
     158   00:80C6  C0                  		ret 	nz		; exit when not at end
     159   00:80C7  0E 08               		ld 	c,8		; x pos to begin of line
     160   00:80C9  04                  		inc 	b		; y pos 1 down
     161   00:80CA  C9                  		ret			; exit
     162   00:80CB                      
     163   00:80CB  C5                  attr		push 	bc		; save xy
     164   00:80CC  D5                  		push	de		; save data or coordinates
     165   00:80CD  CD 9B 0A            		call 	#0a9b		; calculate screen
     166   00:80D0  D1                  		pop	de		; retrieve data or coordinates
     167   00:80D1  C1                  		pop 	bc		; get xy
     168   00:80D2  26 58               		ld 	h,88		; make it attributes at top of screen
     169   00:80D4  3E 28               		ld 	a,40		; test a block
     170   00:80D6  BE                  		cp 	(hl)		
     171   00:80D7  7E                  		ld 	a,(hl)		; get attribute data
     172   00:80D8  C9                  		ret
     173   00:80D9                      
     174   00:80D9                      levels	
     175   00:80D9                      
     176   00:80D9                      ; 2 = startpos player
     177   00:80D9                      ; 4 = 1x wall
     178   00:80D9                      ; 5 = 2x wall
     179   00:80D9                      ; 8 = 1x block on destination 	
     180   00:80D9                      ; 9 = 2x block on destination 	
     181   00:80D9                      ; A = 1x block
     182   00:80D9                      ; B = 2x block
     183   00:80D9                      ; C = 1x destination
     184   00:80D9                      ; D = 2x destination
     185   00:80D9                      ; E = 1x space
     186   00:80D9                      ; F = 2x space
     187   00:80D9                      ; final byte each level is number of boxes not on endposition
     188   00:80D9                      ; also a marker to indicate end of level (the zero).
     189   00:80D9                      
     190   00:80D9                      	db #55,#FE,#5C,#E4,#B2,#5E,#FF,#54,#CF,#A5,#54,#CF,#03 		; 13 bytes ok
     190   00:80D9  55 FE 5C E4 B2 5E FF 54 CF A5 54 CF 03 
     191   00:80E6                      	db #4E,#D5,#54,#EA,#FF,#5F,#4A,#4E,#5F,#2C,#AE,#03		; 12 bytes ok
     191   00:80E6  4E D5 54 EA FF 5F 4A 4E 5F 2C AE 03 
     192   00:80F2                      	db #4E,#CE,#EE,#C5,#F4,#E4,#E5,#CA,#FA,#25,#AE,#55,#5F,#03	; 14 bytes ok
     192   00:80F2  4E CE EE C5 F4 E4 E5 CA FA 25 AE 55 5F 03 
     193   00:8100                      	db #55,#F5,#4F,#DC,#E5,#EA,#CA,#CE,#54,#AB,#25,#5F,#F5,#05	; 14 bytes ok
     193   00:8100  55 F5 4F DC E5 EA CA CE 54 AB 25 5F F5 05 
     194   00:810E                      
     195   00:810E                      endlevel
     196   00:810E                                     	

    LABELS
-------------------------------------------------
00:00008013   start
00:00008016   nlev
00:00008024   displevel
00:0000802C X stlevel
00:00008032   xypos
00:00008040   wkey
00:0000804F X notnkey
00:00008058   t2
00:0000805F   t3
00:00008066   t4
00:0000806D   endkeys
00:00008078   testbox
00:0000808A   not2end
00:0000808F   notfromend
00:00008094   setxy
00:00008098   free_end
00:0000809E   wait
00:000080A1   nkey
00:000080A6   print
00:000080B0   pr1
00:000080BB   dodisp
00:000080CB   attr
00:000080D9   levels
00:0000810E   endlevel


 Output: C:\USB-ZX81\sjasm\SOKOB256\sokob256-011.out
-------------------------------------------------

 Page: 00
  Org: 00008010  Size: *  Used: 000000FE

   Address   Length Align   Label
   00008010     254         start
